﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region ' Shared Files

#Region Quick open for sister projects
'B4A ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4A\TBirdSync.b4a
'B4i ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4i\TBirdSync.b4i
'B4J ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4J\TBirdSync.b4j
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

' Communication between B4A and B4J is based on the example from https://www.b4x.com/android/forum/threads/b4x-b4xpages-network-asyncstreams-b4xserializator.119011/
' The B4J client program is supposed to initiate the connection with the B4A server app in this setup.
' The B4A server app starts at boot (service wmStartAtBoot) and is kept alive with service KeepAlive so that it's always listening.

' CHANGES: see Main module

Sub Class_Globals

	' General
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore

	Public compileInfo As String = ""
	Public compileDate As String = ""
	Public wmUtils1 As wmUtils
	Public Const iconURL As String = "https://www.pngrepo.com/svg/156939/update-business-user"
	Public Const COLOUR_ORANGE As String = "#FF9900"

	' The B4J client doesn't contain module wmContactsUtils; therefore,
	' Type 'contactDetailsThunderbird' is used to store the data in List
	' 'androidContactsList', to make sure that the same Type is used in both
	' B4A and B4J.
	Type contactDetailsThunderbird(Id As Long, displayName As String, firstName As String, lastName As String, nickname As String, _
									fax As String, phoneCell As String, phoneHome As String, phoneWork As String, pager As String, _
									photoPresent As Boolean, _
									postalAddressHome As String, postalAddressWork As String, _
									company As String, jobTitle As String, note As String, _
									websiteHome As String, websiteWork As String, _
									emailHome As String, emailWork As String, _
									IMaim As String, IMmsn As String, IMyahoo As String, IMskype As String, IMqq As String, IMhangouts As String, IMicq As String, IMjabber As String, _
									birthDate As String)

#If B4A
	' Program info
	Public appVersion As String = Application.VersionCode
	Public appName As String = Application.LabelName

	' Latest 'LastModifiedDate' from contacts and calendar/tasks that were observed with the latest sync
	Public cfgSavedLatestContactsLastModifiedDate As String = ""
	Public cfgSavedLatestCalendarLastModifiedDate As String = ""

	' Directories
	Public dirApp As String
	Public dirPhotos As String

	' Various
	Public cu As wmContactsUtils
	Public rp As RuntimePermissions
	Public mustStartAtBoot As Boolean = False
	Public startedAtBoot As Boolean = False
	Public Const ICSx5PackageName As String = "at.bitfire.icsdroid" ' If this woumd change, the Manifest must be changed as well !

	' Communication
	Public server As ServerSocket
	Public client As Socket
	Public cfgServerPort As Int = 0
	Public ser As B4XSerializator
	Public connected As Boolean = False
	Public astream As AsyncStreams
	Public randomId As String
	Public working As Boolean = True

	' Notifications
	Public notif As Notification
	Public notifId As Int = 1
	Public notifIconConnected As String = "connected"
	Public notifIconDisconnected As String = "disconnected"
	Public notifIconSyncing As String = "syncing"
#End If ' B4A

#If B4J
	' General
	Private fx As JFX

	' Program info
	Public appVersion As String = "6.00" ' Make sure this is the same as '#LibraryVersion' (this is used because the Application object doesn't exist in B4J)
	Public appName As String = "TBirdSync"
	Public dirApp As String
	Public dirPhotos As String
	Public OSicon As String

	' Data received from the server
	Private serverDataMap As Map

	' Thunderbird profile folder, .ics file, and .ics file copy
	Private inputDir As String = ""
	Private cfgIcsFile As String = ""
	Private cfgCopyIcsFileFolder As String = ""
	Private cfgIcsFileLastModified As Long = 0

	' Contacts updating - B4J
	Private dialog As B4XDialog
	Private sqlPC As SQL
	Private waitingForAndroidContactsDeletion As Boolean
	Private IDmapTBird As Map
	Private IDmapAndroid As Map
	Private nameMapTBird As Map
	Private contactsFieldsMap As Map

	' Sync prep statuses
	Private syncReadyCalendarAndTasks As Boolean
	Private latestLastModifiedICSentry As String
	Private mustSyncUnchangedCalendar As Boolean

	' Communication
	Public server As ServerSocket
	Public client As Socket
	Public cfgServerPort As Int = 0
	Public ser As B4XSerializator
	Public connected As Boolean = False
	Public astream As AsyncStreams
	Public randomId As String
#End If ' B4J

	' Contacts updating
	Private sqlAndroid As SQL
	Type syncChange(card As String, name As String, action As Int, debugInfo As String, sortName As String, allData As Map)
	Private syncChanges As List
	Private Const ACTION_ADD As Int = 1
	Private Const ACTION_UPDATE As Int = 2
	Private Const ACTION_DELETE As Int = 3
	Private Const ACTION_DELETE_ANDROID As Int = 4
	Private photosMap As Map

	' Designer views
	Private lblStatus As B4XView
	Private lblMyIp As B4XView
	Private BBCodeViewProgress As BBCodeView
	Private BBCodeViewIcon As BBCodeView
	Private TextEngine As BCTextEngine
#If B4A
	Private lblClientIP As B4XView
	Private ButtonSaveActivate As B4XView
	Private txtPassword As EditText
	Private txtPort As EditText
	Private CheckBoxStartAtBoot As B4XView
	Private CheckBoxKeepAlive As B4XView
	Private settingCheckboxes As Boolean = False
	Private lblDeleting As B4XView
#End If ' B4A
#If B4J
	Private btnSync As B4XView
	Private btnConnect As B4XView
	Private txtIP As B4XFloatTextField
	Private txtPassword As B4XFloatTextField
	Private txtPort As B4XFloatTextField
	Private lblInputDir As B4XView
	Private btnSelectInputDir As B4XView
	Private lblICSfile As B4XView
	Private btnSelectICSfile As B4XView
	Private lblCopyICSfileFolder As B4XView
	Private btnCopyICSfileFolder As B4XView
	Private CheckBoxSyncContacts As B4XView
	Private CheckBoxSyncCalendar As B4XView
	Private CustomListViewDialog As CustomListView
#End If ' B4J

End Sub

#Region Core - B4A and B4J

'You can add more parameters here.
Public Sub Initialize

	wmUtils1.Initialize

	compileInfo = wmUtils1.GetCompileInfo(File.DirAssets, "compiletime.txt", appVersion)
	compileDate = wmUtils1.GetCompileDate(File.DirAssets, "compiletime.txt", appVersion)

#If B4A
	wmUtils1.DisableStrictMode ' A long operation will take place
	dirApp = rp.GetSafeDirDefaultExternal("")
	dirPhotos = File.Combine(dirApp, "photos")
	If File.Exists(dirApp, "photos") = False Then File.MakeDir(dirApp, "photos")
	cu.Initialize
	If ReadSettings(False) Then ListenForConnections
	If startedAtBoot And (mustStartAtBoot = False) Then
		ButtonExit_Click
		Return
	End If
	ShowNotification("Disconnected", notifIconDisconnected)
#End If

#If B4J
	dirApp = wmUtils1.MyDirData(appName)
	Log("GetOS=" & wmUtils1.GetOS & "; B4JdirData=" & GetEnvironmentVariable("B4JdirData", "(not set)") & "; dirApp=" & dirApp)

	Select Case wmUtils1.GetOS
		Case "w"
			OSicon = "[Color=Blue][FontAwesome=0xF17A/][/Color] "
		Case "l"
			OSicon = "[Color=Blue][FontAwesome=0xF17C/][/Color] "
		Case "m"
			OSicon = "[Color=Blue][FontAwesome=0xF179/][/Color] "
		Case Else
			OSicon = "[Color=Blue][FontAwesome=0xF109/][/Color] "
	End Select
	dirPhotos = File.Combine(dirApp, "photos")
	ReadSettings(False)

	contactsFieldsMap.Initialize ' 'y'=relevant field to detect updated contacts, 'n'=irrelevant one
	contactsFieldsMap.Put("_aimscreenname", "y")
	contactsFieldsMap.Put("birthday", "y")
	contactsFieldsMap.Put("birthmonth", "y")
	contactsFieldsMap.Put("birthyear", "y")
	contactsFieldsMap.Put("categories", "n")
	contactsFieldsMap.Put("cellularnumber", "y")
	contactsFieldsMap.Put("company", "y")
	contactsFieldsMap.Put("custom1", "y")
	contactsFieldsMap.Put("custom2", "y")
	contactsFieldsMap.Put("custom3", "y")
	contactsFieldsMap.Put("custom4", "y")
	contactsFieldsMap.Put("department", "y")
	contactsFieldsMap.Put("displayname", "n")
	contactsFieldsMap.Put("faxnumber", "y")
	contactsFieldsMap.Put("firstname", "y")
	contactsFieldsMap.Put("_googletalk", "y")
	contactsFieldsMap.Put("homeaddress", "y")
	contactsFieldsMap.Put("homeaddress2", "y")
	contactsFieldsMap.Put("homecity", "y")
	contactsFieldsMap.Put("homecountry", "y")
	contactsFieldsMap.Put("homephone", "y")
	contactsFieldsMap.Put("homestate", "y")
	contactsFieldsMap.Put("homezipcode", "y")
	contactsFieldsMap.Put("_icq", "y")
	contactsFieldsMap.Put("_irc", "n")
	contactsFieldsMap.Put("_jabberid", "y")
	contactsFieldsMap.Put("jobtitle", "y")
	contactsFieldsMap.Put("lastmodifieddate", "n")
	contactsFieldsMap.Put("lastname", "y")
	contactsFieldsMap.Put("_msn", "y")
	contactsFieldsMap.Put("nickname", "y")
	contactsFieldsMap.Put("notes", "y")
	contactsFieldsMap.Put("pagernumber", "y")
	contactsFieldsMap.Put("photoname", "y")
	contactsFieldsMap.Put("phototype", "y")
	contactsFieldsMap.Put("photouri", "n")
	contactsFieldsMap.Put("popularityindex", "n")
	contactsFieldsMap.Put("preferdisplayname", "n")
	contactsFieldsMap.Put("prefermailformat", "n")
	contactsFieldsMap.Put("primaryemail", "y")
	contactsFieldsMap.Put("_qq", "y")
	contactsFieldsMap.Put("secondemail", "y")
	contactsFieldsMap.Put("_skype", "y")
	contactsFieldsMap.Put("webpage1", "y")
	contactsFieldsMap.Put("webpage2", "y")
	contactsFieldsMap.Put("workaddress", "y")
	contactsFieldsMap.Put("workaddress2", "y")
	contactsFieldsMap.Put("workcity", "y")
	contactsFieldsMap.Put("workcountry", "y")
	contactsFieldsMap.Put("workphone", "y")
	contactsFieldsMap.Put("workstate", "y")
	contactsFieldsMap.Put("workzipcode", "y")
	contactsFieldsMap.Put("_yahoo", "y")
#End If

End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created(Root1 As B4XView)

	Root = Root1
	'load the layout to Root
	Root.LoadLayout("1")

	B4XPages.SetTitle(Me, appName & " v" & appVersion & " (" & compileDate & ")")

#If B4J
	For Each txt As B4XFloatTextField In Array(txtPort, txtPassword, txtIP)
		txt.LargeLabelTextSize = 14
		txt.SmallLabelTextSize = 10
		txt.Update
	Next
#End If ' B4J

	TextEngine.Initialize(Root)
	BBCodeViewProgress.TextEngine = TextEngine

	UpdateState(connected) ' Done here to correctly update lblStatus, as this was not yet possible in the Initialize sub

#If B4A
	If CheckBoxKeepAlive.Checked Then StartServiceAtExact(KeepAlive, DateTime.Now + 1 * 60 * 1000, True) ' Keep the app alive; this service will start after 1 minute

	AddMenuItem("", "", Chr(0xF0EA), wmColorNames.Blues.Dark_blue, "Copy .ics URI to Clipboard")
	AddMenuItem("", "", Chr(0xF0F6), wmColorNames.Black_White_Gray.Black, "Show debug log")
	AddMenuItem("", "", Chr(0xF12D), wmColorNames.Black_White_Gray.Black, "Reset debug log")
	AddMenuItem("", Chr(0xE7FC), "", wmColorNames.Reds.Red, "Reset contacts")
	AddMenuItem("", "", Chr(0xF073), wmColorNames.Reds.Red, "Reset calendar")

	Wait For (CheckPermissions) Complete (Success As Boolean)
	If Success = False Then
		ButtonExit_Click
		Return
	End If

#End If ' B4A

End Sub

Private Sub B4XPage_Appear

	BBCodeViewIcon.Text = "[img FileName=""icon.png"" width=26 height=26 vertical=5/] [url]" & iconURL & "[/url]"

	ReadSettings(True) ' Must do this here in order to have the txt... views' texts and the checkboxes updated
	Sleep(0)

#If B4A
	ICSx5isPresent(False) ' Just letting the app show whether or not app ICSx5 is present
#End If

#If B4J
	'https://www.b4x.com/android/forum/threads/solved-hide-scrollbar-bbcodeview.120803/ :
	Dim sp As ScrollPane = BBCodeViewIcon.sv
	sp.SetVScrollVisibility("NEVER")

	Dim arial14 As Font = fx.CreateFont("Arial", 14, True, False)
	wmUtils1.SetAllToolTipFonts(B4XPages.GetNativeParent(Me), arial14, False)

	If Main.autostart Then ConnectToServer ' Command line argument 'sync' was used, so go for it
#End If

End Sub

Private Sub BBCodeViewIcon_LinkClicked (URL As String)

#If B4J
	fx.ShowExternalDocument(URL)
#Else If B4A
	Dim pi As PhoneIntents
	StartActivity(pi.OpenBrowser(URL))
#End If

End Sub

Sub ReadSettings(updateViews As Boolean) As Boolean

	Dim reslt As Boolean = True
	Dim m As Map
	Dim raf As RandomAccessFile
	Dim i As Int
	Dim s As String

	If File.Exists(dirApp, "settings.txt") = False Then Return False

	Try
		m.Initialize
		raf.Initialize(dirApp, "settings.txt", True)
		m = raf.ReadObject(raf.CurrentPosition) ' Must use RAF and ReadObject/WriteObject because without File.WriteObject, everything would be converted to String, including the List-type objects !
		raf.Close
		i = wmUtils1.GetFromMapAsInt(m, "serverport", 0)
		If i > 0 Then
			cfgServerPort = i
			If updateViews Then txtPort.Text = i
		Else
			reslt = False
		End If
		s = m.GetDefault("password", "")
		If s.Length < 1 Then
			reslt = False
		Else If updateViews Then
			txtPassword.Text = s
		End If
#If B4A
		cfgSavedLatestContactsLastModifiedDate = m.GetDefault("savedlatestcontactslastmodifieddate", "") ' Used to determine whether or not contacts data may need updating
		cfgSavedLatestCalendarLastModifiedDate = m.GetDefault("savedlatestcalendarlastmodifieddate", "") ' Used to determine whether or not calendar data may need updating
		settingCheckboxes = True
		mustStartAtBoot = wmUtils1.GetFromMapAsBoolean(m, "startatboot", False)
		If updateViews Then
			CheckBoxStartAtBoot.Checked = mustStartAtBoot
			CheckBoxKeepAlive.Checked = wmUtils1.GetFromMapAsBoolean(m, "keepalive", False)
		End If
		settingCheckboxes = False
#End If
#If B4J
		s = m.GetDefault("serverip", "")
		If s.Length < 1 Then
			reslt = False
		Else If updateViews Then
			txtIP.Text = s
		End If
		cfgIcsFile = m.GetDefault("icsfile", "")
		cfgCopyIcsFileFolder = m.GetDefault("copyicsfilefolder", "")
		cfgIcsFileLastModified = wmUtils1.GetFromMapAsLong(m, "icsfilelastmodified", 0)
		inputDir = m.GetDefault("inputdir", "") ' The Thunderbird profile folder on the PC
		dirPhotos = File.Combine(inputDir, "Photos")
		If IsinputDirOK(False) = False Then
			inputDir = ""
			dirPhotos = ""
		End If
		If updateViews Then
			lblICSfile.Text = cfgIcsFile
			lblCopyICSfileFolder.Text = cfgCopyIcsFileFolder
			lblInputDir.Text = inputDir
			CheckBoxSyncCalendar.Checked = wmUtils1.GetFromMapAsBoolean(m, "synccalendar", False)
			CheckBoxSyncContacts.Checked = wmUtils1.GetFromMapAsBoolean(m, "synccontacts", False)
		End If
#End If
	Catch
		Log("Error reading settings.txt: " & LastException)
		reslt = False
	End Try

	Return reslt

End Sub

Sub btnSaveSettings_Click

	DoWriteSettings(False, "", "")

End Sub

Sub DoWriteSettings(includeSpecificPair As Boolean, specificKey As String, specificValue As String)

	Dim m As Map
	Dim raf As RandomAccessFile

	If File.Exists(dirApp, "settings.txt") Then File.Delete(dirApp, "settings.txt")

	m.Initialize
	If includeSpecificPair Then m.Put(specificKey, specificValue)
	m.put("serverport", cfgServerPort)
	m.Put("password", txtPassword.Text)
#If B4J
	m.Put("serverip", txtIP.Text)
	m.Put("inputdir", inputDir)
	m.Put("synccalendar", CheckBoxSyncCalendar.Checked)
	m.Put("synccontacts", CheckBoxSyncContacts.Checked)
	m.Put("icsfile", cfgIcsFile)
	m.Put("copyicsfilefolder", cfgCopyIcsFileFolder)
#Else
	m.Put("startatboot", CheckBoxStartAtBoot.Checked)
	m.Put("keepalive", CheckBoxKeepAlive.Checked)
#End If
	raf.Initialize(dirApp, "settings.txt", False)
	raf.WriteObject(m, False, raf.CurrentPosition) ' Must use RAF and ReadObject/WriteObject because without File.WriteObject, everything would be converted to String, including the List-type objects !
	raf.Close

End Sub

Sub txtPort_TextChanged(Old As String, New As String)

#If B4A
	EnableButtonSaveActivate
#Else
	EnableBtnConnectAndCheckboxes
#End If

End Sub

Sub txtPassword_TextChanged(Old As String, New As String)

#If B4A
	EnableButtonSaveActivate
#Else
	EnableBtnConnectAndCheckboxes
#End If

End Sub

Sub CloseExistingConnection(calledFromUpdateState As Boolean, closeServer As Boolean)

	If astream.IsInitialized Or client.IsInitialized Or server.IsInitialized Then ReportProgress("Closing connection", False, "Black")
	If astream.IsInitialized Then astream.Close
	If client.IsInitialized Then client.Close
#If B4A
	If closeServer And server.IsInitialized Then server.Close
#Else If B4J
	waitingForAndroidContactsDeletion = False
	If server.IsInitialized Then server.Close
#End If
	If calledFromUpdateState = False Then UpdateState(False)

#If B4J ' Client
	btnSync.Visible = False
#End If

End Sub

Sub AStream_Error

	UpdateState(False)

End Sub

Sub AStream_Terminated

	UpdateState(False)

End Sub

Sub UpdateState(NewState As Boolean)

	connected = NewState

	If connected Then
#If B4J
		If btnConnect.IsInitialized Then btnConnect.Text = "Disconnect"
#End If
		If lblStatus.IsInitialized Then lblStatus.Text = "Connected"
	Else
#If B4J
		If btnConnect.IsInitialized Then btnConnect.Text = "Connect"
		If btnSync.IsInitialized Then btnSync.Visible = False
#End If
#If B4A
		If lblClientIP.IsInitialized Then lblClientIP.Text = ""
		If connected Then
			ShowNotification("Connected", notifIconConnected)
		Else
			If lblDeleting.IsInitialized Then lblDeleting.Visible = False
			ShowNotification("Disconnected", notifIconDisconnected)
		End If
#End If
		If lblStatus.IsInitialized Then lblStatus.Text = "Disconnected"
	End If

	If lblMyIp.IsInitialized Then lblMyIp.Text = "My IP: " & server.GetMyIP

End Sub

Sub AStream_NewData(Buffer() As Byte)

#If B4A
	AStream_NewData_Server(Buffer)
#Else
	AStream_NewData_Client(Buffer)
#End If

End Sub

Sub ReportProgress(txt As String, txtReceivedFromAndroid As Boolean, txtColour As String)

	Dim s As String = ""

	If txt <> "" Then
		If txtColour.EqualsIgnoreCase("Blue") Then ' Warning
			s = "Warning: "
		Else If txtReceivedFromAndroid Then
			s = "Android: "
		Else
			s = "Client OS: "
		End If
		If BBCodeViewProgress.IsInitialized = False Then s = s.Replace(":", "-")
		Log(s & txt)
	End If

	Try
		If BBCodeViewProgress.IsInitialized Then
			If txt = "" Then
				BBCodeViewProgress.Text = CRLF & BBCodeViewProgress.Text
			Else
				s = ""
#If B4J
				If txtColour.EqualsIgnoreCase("Blue") Then ' Warning
					s = "[Color=" & COLOUR_ORANGE & "]" & "[FontAwesome=0xF071/][/Color] "
				Else If txtReceivedFromAndroid Then
					s = "[Color=#228B22]" & "[FontAwesome=0xF17B/][/Color] " ' Color: Forest Green
				Else
					s = OSicon
				End If
#End If
				s = s & "[Color=" & txtColour & "]"
				BBCodeViewProgress.Text = s & wmUtils1.DateToTimeStampForFilename(DateTime.Now) & ": [Plain]" & txt & "[/Plain][/Color]" & CRLF & BBCodeViewProgress.Text
			End If
		End If
		Sleep(10)
	Catch
		Log("ReportProgress error: " & LastException)
	End Try

End Sub

Sub ReportProgress2(txt As String, txtReceivedFromAndroid As Boolean)

	' Don't add a new line, but overwrite the top line, when reporting every 'n' items processed

	Dim idxCRLF As Int

	Try
		If BBCodeViewProgress.IsInitialized Then
			Dim s As String = ""
#If B4J
			If txtReceivedFromAndroid Then
				s = "[Color=#228B22]" & "[FontAwesome=0xF17B/][/Color] " ' Color: Forest Green
			Else
				s = OSicon
			End If
#End If
			idxCRLF = BBCodeViewProgress.Text.IndexOf(CRLF)
			If (idxCRLF < 0) Or (idxCRLF = (BBCodeViewProgress.Text.Length - 1)) Then
				BBCodeViewProgress.Text = s & wmUtils1.DateToTimeStampForFilename(DateTime.Now) & ": [Plain]" & txt & "[/Plain]" & CRLF & BBCodeViewProgress.Text
			Else
				BBCodeViewProgress.Text = s &wmUtils1.DateToTimeStampForFilename(DateTime.Now) & ": [Plain]" & txt & "[/Plain]" & CRLF & BBCodeViewProgress.Text.SubString(idxCRLF + 1)
			End If
		Else
			Log("ReportProgress2: " & wmUtils1.DateToTimeStampForFilename(DateTime.Now) & ": " & txt)
		End If
		Sleep(5)
	Catch
		Log("ReportProgress2: " & LastException)
	End Try

End Sub

Public Sub SendDataMap(dataMap As Map)

	' Send a Map with data to the other component

	If connected Then
		If dataMap.GetDefault("action", "") <> "connect" Then dataMap.Put("randomid", randomId)
		astream.Write(ser.ConvertObjectToBytes(dataMap))
	End If

End Sub

#End Region ' Core - B4A and B4J

#Region Core B4J

#If B4J
Private Sub B4XPage_Disappear

	Dim raf As RandomAccessFile
	Dim m As Map
	m.Initialize

	CloseExistingConnection(True, False) ' True: we don't want UpdateState to be called

	If File.Exists(dirApp, "settings.txt") Then
		Try
			raf.Initialize(dirApp, "settings.txt", True)
			m = raf.ReadObject(raf.CurrentPosition) ' Must use RAF and ReadObject/WriteObject because without File.WriteObject, everything would be converted to String, including the List-type objects !
			raf.Close
		Catch
			Log("B4XPage_Disappear - error reading settings.txt: " & LastException)
			m.Initialize
		End Try
	End If
	wmUtils1.FormSaveSettings2(B4XPages.GetNativeParent(Me), dirApp, "settings.txt", m)

End Sub

Sub ButtonCopyText_Click

	Dim s As String = BBCodeViewProgress.Text
	fx.Clipboard.SetString(Regex.replace("[\[].*?[\]]", s, "")) ' Regex pattern to remove BBCodeView tags from text based on https://www.codegrepper.com/code-examples/python/regex+remove+text+between+square+brackets+python

End Sub

Sub btnSync_Click

	mustSyncUnchangedCalendar = False
	PrepareSync(True)

End Sub

Sub PrepareSync(firstTime As Boolean)

	Dim mustSyncContacts As Boolean = False
	Dim mustSyncCalendar As Boolean = False

	btnSync.Visible = False ' Avoid to click the Sync button while a sync is in progress
	Sleep(0)

	If CheckBoxSyncCalendar.Checked Then
		If (cfgIcsFile = "") Or (File.Exists(cfgIcsFile, "") = False) Then
			xui.MsgboxAsync("The selected .ics file does not exist", appName)
			btnSelectICSfile.RequestFocus
			btnSync.Visible = True
			Sleep(0)
			Return
		End If
		If firstTime Then
			If File.LastModified(cfgIcsFile, "") = cfgIcsFileLastModified Then
				Dim sf As Object
				sf = xui.Msgbox2Async("It looks like the Thunderbird calendar/tasks .ics file has not changed since the last sync run. Sync calendar and tasks anyway?", appName, "Yes", "", "No", Null)
				Wait For (sf) Msgbox_Result (Result As Int)
				If Result = xui.DialogResponse_Positive Then
					mustSyncCalendar = True
					mustSyncUnchangedCalendar = True
				End If
			Else
				mustSyncCalendar = True
			End If
		Else
			mustSyncCalendar = mustSyncUnchangedCalendar
		End If
		If mustSyncCalendar Then
			PrepareSyncCalendarAndTasks ' Prepare calendar data to send to the B4A app
			If syncReadyCalendarAndTasks = False Then
				CloseExistingConnection(False, False)
				btnSync.Visible = True
				Sleep(0)
				Return
			End If
			DoWriteSettings(True, "icsfilelastmodified", "" & File.LastModified(cfgIcsFile, "")) ' Save this value in the Settings file
		End If
	End If

	If (CheckBoxSyncContacts.Checked) And (serverDataMap.ContainsKey("contactsandroid")) Then ' Android contacts have been collected by B4A, which means changes were detected in the Thunderbird contacts
		Dim rs As ResumableSub = PrepareSyncContacts(waitingForAndroidContactsDeletion) ' Prepare contacts data to send to the B4A app
		Wait For (rs) Complete(bResult As Boolean)
		If bResult = False Then
			CloseExistingConnection(False, False)
			Return
		End If
		If waitingForAndroidContactsDeletion Then Return ' Wait for the B4A server to delete the Android device's contacts; afterwards, this here Sub will be called again
		mustSyncContacts = True
	End If

	If (mustSyncCalendar = False) And (mustSyncContacts = False) Then
		ReportProgress("There are no changed data to sync", False, "Blue")
		CloseExistingConnection(False, False)
		btnSync.Visible = True
		Sleep(0)
		Return
	End If

	' Create a copy of the prepared .ics file?
	If cfgCopyIcsFileFolder <> "" Then
		Try
			ReportProgress("Copying the prepared .ics file to " & File.Combine(cfgCopyIcsFileFolder, "todo2event.ics"), False, "Black")
			If File.Exists(cfgCopyIcsFileFolder, "todo2event.ics") Then File.Delete(cfgCopyIcsFileFolder, "todo2event.ics")
			File.Copy(dirApp, "todo2event.ics", cfgCopyIcsFileFolder, "todo2event.ics")
			ReportProgress("The prepared .ics file was copied to " & File.Combine(cfgCopyIcsFileFolder, "todo2event.ics"), False, "Black")
		Catch
			Dim s As String = "Warning: could not save a copy of the prepared .ics file: " & CRLF & CRLF & LastException
			ReportProgress(s, False, "Red")
			xui.MsgboxAsync(s, appName)
		End Try
	End If

	' Send the changes to the Android device
	ReportProgress("Sending changes to the Android device", False, "Black")
	Dim mapOut As Map
	mapOut.Initialize
	mapOut.Put("action", "dosync")
	' Old method without zipping the file
	' If mustSyncCalendar Then mapOut.Put("syncics", File.ReadList(dirApp, "todo2event.ics")) ' This file was prepared in sub PrepareSyncCalendarAndTasks
	If mustSyncCalendar Then mapOut.Put("syncics", File.ReadBytes(dirApp, "todo2event.zip")) ' This file was prepared in sub PrepareSyncCalendarAndTasks
	If mustSyncContacts Then
		mapOut.Put("latestcontactslastmodifieddate", GetLatestContactsLastModifiedDate)
		mapOut.Put("syncchanges", syncChanges) ' These data were prepared in sub ContactsSync
		mapOut.Put("photos", photosMap) ' These data were prepared in sub ContactsSync
	End If
	SendDataMap(mapOut) ' Over to the B4A app now to perform the sync operations

End Sub

Sub btnSelectInputDir_Click

	' Note: this caused an exception when used in debug mode; works fine in release mode.
	' This was also spotted by mw71: https://www.b4x.com/android/forum/threads/solved-trouble-with-directorychooser-b4xpages.127932

	Dim directoryChooser1 As DirectoryChooser
	Dim oldDir As String = inputDir

	directoryChooser1.Initialize
	If File.Exists(inputDir, "") Then directoryChooser1.InitialDirectory = inputDir
	directoryChooser1.Title = "Select the Thunderbird profile directory"
	inputDir = directoryChooser1.Show(B4XPages.GetNativeParent(Me))

	If inputDir = "" Then
		inputDir = oldDir
	Else If IsinputDirOK(True) Then
		lblInputDir.Text = inputDir
	Else
		inputDir = oldDir
	End If

	EnableBtnConnectAndCheckboxes

End Sub

Sub IsinputDirOK(showMsg As Boolean) As Boolean

	If inputDir <> "" Then
		If File.Exists(inputDir, "") = False Then ' Thunderbird profile folder doesn't exist
			inputDir = ""
		Else If File.Exists(inputDir, "abook.sqlite") = False Then ' Thunderbird address book file doesn't exist
			inputDir = ""
		Else If File.Exists(inputDir, "Photos") = False Then ' Thunderbird photos folder doesn't exist
			inputDir = ""
		End If
	End If

	If showMsg And (inputDir = "") Then xui.MsgboxAsync("Select the proper Thunderbird profile directory first. This directory is expected to contain:" & CRLF & "- file: abook.sqlite" & CRLF & "- directory: Photos", appName)

	Return (inputDir <> "")

End Sub

Sub btnSelectICSfile_Click

	Dim fileChooser1 As FileChooser
	Dim oldFile As String = cfgIcsFile

	fileChooser1.Initialize
	If File.Exists(cfgIcsFile, "") Then
		fileChooser1.InitialDirectory = File.GetFileParent(cfgIcsFile)
		fileChooser1.InitialFileName = File.GetName(cfgIcsFile)
	End If
	fileChooser1.Title = "Select the .ics file that is exported with Thunderbird"
	fileChooser1.setExtensionFilter("ICS files", Array As String("*.ics"))
	cfgIcsFile = fileChooser1.ShowOpen(B4XPages.GetNativeParent(Me))
	If cfgIcsFile = "" Then
		cfgIcsFile = oldFile
		Return
	End If

	lblICSfile.Text = cfgIcsFile

	EnableBtnConnectAndCheckboxes

End Sub

Private Sub btnCopyICSfileFolder_Click

	' Note: this caused an exception when used in debug mode; works fine in release mode.
	' This was also spotted by mw71: https://www.b4x.com/android/forum/threads/solved-trouble-with-directorychooser-b4xpages.127932

	Dim directoryChooser1 As DirectoryChooser
	directoryChooser1.Initialize
	If File.Exists(cfgCopyIcsFileFolder, "") Then directoryChooser1.InitialDirectory = cfgCopyIcsFileFolder
	directoryChooser1.Title = "Select the folder to store a copy of the generated .ics file"
	cfgCopyIcsFileFolder = directoryChooser1.Show(B4XPages.GetNativeParent(Me))
	lblCopyICSfileFolder.Text = cfgCopyIcsFileFolder

End Sub

Sub txtIP_TextChanged(Old As String, New As String)

	EnableBtnConnectAndCheckboxes

End Sub

Sub EnableBtnConnectAndCheckboxes

	' Ensure all data have been entered correctly before attempting a connection

	Dim b As Boolean = False

	If txtPort.Text <> "" Then
		If IsNumber(txtPort.Text) Then
			Dim i As Int = txtPort.Text
			If i > 0 Then
				b = True
				cfgServerPort = i
			End If
		End If
	End If

	b = b And (txtIP.Text.Length > 0) And (cfgServerPort > 0) And _
		(txtPassword.Text.Length > 0) And (lblInputDir.Text.Length > 0) And _
		File.Exists(lblInputDir.Text, "")

	If cfgCopyIcsFileFolder <> "" Then
		If File.Exists(cfgCopyIcsFileFolder, "") = False Then b = False
	End If

	btnConnect.Visible = b
	If b Then
		If lblICSfile.Text = "" Then
			CheckBoxSyncCalendar.Checked = False
			CheckBoxSyncCalendar.Enabled = False
		Else
			CheckBoxSyncCalendar.Enabled = True
		End If
	End If

End Sub

Sub AStream_NewData_Client(Buffer() As Byte)

	Dim mapIn As Map = ser.ConvertBytesToObject(Buffer)

	If wmUtils1.GetFromMapAsBoolean(mapIn, "success", False) = False Then ' An error is being reported
		ReportProgress(mapIn.GetDefault("error", ""), True, "Red")
		UpdateState(False)
		Return
	End If

	Select mapIn.Get("svraction")
		Case "connected" ' B4A server connection successful; the server has also reported which data sets are appropriate to be synced
			waitingForAndroidContactsDeletion = False
			Dim canSyncContacts As Boolean = wmUtils1.GetFromMapAsBoolean(mapIn, "cansynccontacts", False)
			Dim canSyncCalendar As Boolean = wmUtils1.GetFromMapAsBoolean(mapIn, "cansynccalendar", False)
			If (canSyncContacts = False) And (canSyncCalendar = False) And (CheckBoxSyncCalendar.Checked = False) Then
				' Nothing to sync
				btnSync.Visible = False
			Else
				btnSync.Visible = True
				ReportProgress("Connection made, data received, ready for sync", False, "Black")
			End If
			serverDataMap = mapIn
			randomId = mapIn.GetDefault("randomid", "")
			UpdateState(True)
			If btnSync.Visible And Main.autostart Then PrepareSync(True)
		Case "deleteandroidcontacts"
			PrepareSync(False)
		Case "info" ' B4A server reports information
			ReportProgress(mapIn.Get("info"), True, mapIn.GetDefault("txtcolour", "Black"))
		Case "info2" ' B4A server reports information
			ReportProgress2(mapIn.Get("info2"), True)
		Case "syncd" ' Synchronisation completed, report metrics
			ReportProgress(mapIn.GetDefault("metrics", ""), True, "Black")
			ReportProgress("Synchronisation completed", False, "Black")
			UpdateState(False)
			CloseExistingConnection(False, False)
		Case Else ' This should not occur; it's an oversight in the code
			ReportProgress("Unhandled server action: " & mapIn.Get("svraction"), False, "Red")
			Return
	End Select

End Sub

Sub btnConnect_Click

	If connected Then
		CloseExistingConnection(False, False)
	Else
		If (CheckBoxSyncCalendar.Checked = False) And (CheckBoxSyncContacts.Checked = False) Then
			xui.MsgboxAsync("Use the checkboxes to indicate the data to be synchronised", appName)
			Return
		End If
		ConnectToServer
	End If

End Sub

Private Sub ConnectToServer

	' Connect to the B4A server. Based on the example from https://www.b4x.com/android/forum/threads/b4x-b4xpages-network-asyncstreams-b4xserializator.119011/

	Dim s As String

	CloseExistingConnection(False, False)

	Try
		server.Initialize(cfgServerPort, "server")
	Catch
		Wait For(wmUtils1.MsgBoxLongText(B4XPages.GetNativeParent(Me), 500dip, 300dip, "Couldn't activate the server:" & CRLF & LastException, appName, "OK", "", "", xui.Color_Red)) Complete (result As Int)
		UpdateState(False)
		Return
	End Try

	BBCodeViewProgress.Text = "[Color=" & COLOUR_ORANGE & "]" & "[FontAwesome=0xF071/][/Color] " & "[Color=" & "Blue" & "]" & "WARNING: if data are edited (added/updated/deleted) on the Android device, changes will not be detected. All changes are expected to be applied in Thunderbird!" & CRLF & "[/Color]"
	ReportProgress("Trying to connect", False, "Black")

	Dim client As Socket ' Local variables in B4X never hide global variables. This means that this code initializes the global variable again. This is on purpose as you cannot reuse a socket object. (https://www.b4x.com/android/forum/threads/b4x-network-asyncstreams-b4xserializator.72149/)
	client.Initialize("client")
	client.Connect(txtIP.Text, cfgServerPort, 10000)
	Wait For Client_Connected (Successful As Boolean)
	If Successful = False Then
		s = "Failed to connect"
		ReportProgress(s, False, "Red")
		UpdateState(False)
		xui.MsgboxAsync(s, appName)
		Return
	End If

	UpdateState(True) ' Even though the password handshake still needs to be done, we're already setting 'connected' to True in UpdateState, as SendDataMap tests for 'connected = True'
	ReportProgress("Connected to server, sending password", False, "Black")
	astream.InitializePrefix(client.InputStream, False, client.OutputStream, "astream")
	PrepareSyncCalendarAndTasks ' This is done here to set 'latestLastModifiedICSentry'

	Dim sqlPCwasInitialized As Boolean = sqlPC.IsInitialized
	Try
		If sqlPC.IsInitialized = False Then sqlPC.InitializeSQLite(inputDir, "abook.sqlite", False)
	Catch
		s = "Couldn't open the Thunderbird database" & CRLF & CRLF & File.Combine(inputDir, "abook.sqlite") & CRLF & CRLF & LastException
		ReportProgress(s, False, "Red")
		Wait For(wmUtils1.MsgBoxLongText(B4XPages.GetNativeParent(Me), 500dip, 300dip, s, appName, "OK", "", "", xui.Color_Red)) Complete (result As Int)
		Return
	End Try
	Dim mustReturn As Boolean = False
	Try
		Dim numberOfTbirdContacts As Int = sqlPC.ExecQuerySingleResult("SELECT count(DISTINCT [card]) FROM [properties]")
	Catch
		Dim s As String = LastException
		If s.Contains("database is locked") Then
			s = "Couldn't query the Thunderbird database; you may need to close Thunderbird" & CRLF & CRLF & File.Combine(inputDir, "abook.sqlite") & CRLF & CRLF & s
		Else
			s = "Couldn't query the Thunderbird database" & CRLF & CRLF & File.Combine(inputDir, "abook.sqlite") & CRLF & CRLF & s
		End If
		ReportProgress(s, False, "Red")
		Wait For(wmUtils1.MsgBoxLongText(B4XPages.GetNativeParent(Me), 500dip, 300dip, s, appName, "OK", "", "", xui.Color_Red)) Complete (result As Int)
		mustReturn = True
	End Try
	If sqlPCwasInitialized = False Then sqlPC.Close
	If mustReturn Then Return

	' Send information to the B4A server; it will be used there
	Dim mapOut As Map
	mapOut.Initialize
	mapOut.put("action", "connect")
	mapOut.put("password", txtPassword.Text)
	mapOut.Put("clientip", server.GetMyIP)
	mapOut.Put("synccalendar", CheckBoxSyncCalendar.Checked)
	mapOut.Put("synccontacts", CheckBoxSyncContacts.Checked)
	mapOut.Put("numberoftbirdcontacts", numberOfTbirdContacts) ' Will be used by the B4A server to detect if contacts were deleted in Thunderbird
	mapOut.Put("latestcontactslastmodifieddate", GetLatestContactsLastModifiedDate)
	mapOut.Put("latestcalendarlastmodifieddate", latestLastModifiedICSentry)
	SendDataMap(mapOut)

End Sub

Sub GetLatestContactsLastModifiedDate As String

	' Get the latest 'LastModifiedDate' from the Thunderbird Address Book database on the PC

	Try
		Dim sqlPChere As SQL
		If sqlPC.IsInitialized Then
			sqlPChere = sqlPC
		Else
			sqlPChere.InitializeSQLite(inputDir, "abook.sqlite", False)
		End If
		Dim o As Object = sqlPChere.ExecQuerySingleResult("SELECT [value] FROM [properties] WHERE [name]='LastModifiedDate' ORDER BY [value] DESC LIMIT 1")
		If sqlPC.IsInitialized = False Then sqlPChere.Close
		If o <> Null Then
			Return o
		Else
			Return ""
		End If
	Catch
		Return ""
	End Try

End Sub

#End If ' B4J

#End Region ' Core B4J

#Region Core B4A

#If B4A
Public Sub ListenForConnections

	' Listen for incoming connection requests from the B4J client program

	CloseExistingConnection(False, True)

	ReportProgress("Initialising server", True, "Black")
	Try
		server.Initialize(cfgServerPort, "server")
	Catch
		xui.MsgboxAsync("Couldn't activate the server:" & CRLF & LastException, appName)
		UpdateState(False)
		Return
	End Try

	ReportProgress("Listening for client connection requests", True, "Black")
	Do While working
		server.Listen
		Wait For Server_NewConnection(Successful As Boolean, NewSocket As Socket)
		If Successful Then
			' If a client is already connected, disconnect first
			If connected Then CloseExistingConnection(False, False)
			ReportProgress("Client connected", True, "Black")
			client = NewSocket
			astream.InitializePrefix(client.InputStream, False, client.OutputStream, "astream")
			UpdateState(True)
		End If
	Loop

End Sub

Sub ShowNotification(txt As String, icon As String)

	Try
		If notif.IsInitialized Then notif.Cancel(notifId)
	Catch
		Log("ShowNotification: " & LastException)
	End Try

	Try
		notif.Initialize
		notif.Insistent = False
		notif.Light = False
		notif.OnGoingEvent = True
		notif.Sound = False
		notif.Vibrate = False
		notif.Icon = icon
		notif.Number = notifId
		notif.SetInfo(Application.LabelName, txt & " (" & wmUtils1.GetTimeStampForFilename & ")", Main)
		notif.Notify(notifId)
	Catch
		Log("ShowNotification: " & LastException)
	End Try

End Sub

Sub CheckPermissions As ResumableSub

	' Based on https://www.b4x.com/android/forum/threads/class-contactsutils-provides-read-write-access-to-the-stored-contacts.30824/
	For Each per In Array(rp.PERMISSION_READ_CONTACTS, rp.PERMISSION_WRITE_CONTACTS)
		rp.CheckAndRequest(per)
		Wait For B4XPage_PermissionResult (permission As String, Result As Boolean)
		If Result = False Then
			Msgbox("Permission '" & permission & "' was denied, terminating", Application.LabelName)
			Return False
		End If
	Next
	Return True

End Sub

Sub AddMenuItem(iconFile As String, chrMaterialIcons As String, chrFontAwesome As String, iconColour As Int, txt As String)

	Dim cs As CSBuilder
	Dim mi As B4AMenuItem

	If iconFile <> "" Then
		mi = B4XPages.AddMenuItem(Me, txt)
		mi.Bitmap = xui.LoadBitmapResize(File.DirAssets, iconFile, 64dip, 64dip, True)
	Else If chrMaterialIcons <> "" Then
		mi = B4XPages.AddMenuItem(Me, cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(wmUtils1.IntToColour(iconColour)).Append(chrMaterialIcons).Typeface(Typeface.DEFAULT).Append(" ").Append(txt).PopAll)
	Else If chrFontAwesome <> "" Then
		mi = B4XPages.AddMenuItem(Me, cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(wmUtils1.IntToColour(iconColour)).Append(chrFontAwesome).Typeface(Typeface.DEFAULT).Append(" ").Append(txt).PopAll)
	Else
		mi = B4XPages.AddMenuItem(Me, txt)
	End If

	mi.Tag = txt
	mi.AddToBar = False

End Sub

Sub B4XPage_MenuClick(Tag As String)

	Select Case Tag
		Case "Copy .ics URI to Clipboard" ' ... so that the user can paste it in the ICSx5 app to subscribe to sync the calendar from this source
			Try
				Dim clip As BClipboard
				clip.clrText
				clip.setText("file://" & File.Combine(dirApp, "todo2event.ics")) ' File "todo2event.ics" is created after receiving the sync request from the B4J program, using the data that were transmitted
				xui.MsgboxAsync("file://" & File.Combine(dirApp, "todo2event.ics"), "Copied to Clipboard")
			Catch
				xui.MsgboxAsync("Clipboard copy failed: " & LastException, appName)
			End Try
		Case "Show debug log" ' This log may contain information after a fatal exception - just in case
			ShowWmDebugLog_Click
		Case "Reset debug log" ' Empties that log file
			ResetWmDebugLog_Click
		Case "Reset contacts" ' After doing this, the B4A server app considers the next contacts sync the first one ever
			ResetContacts_Click
		Case "Reset calendar" ' After doing this, the B4A server app considers the next calendar/tasks sync the first one ever
			ResetCalendar_Click
	End Select

End Sub

Private Sub B4XPage_Disappear

	B4XPages.GetManager.ActionBar.RunMethod("setHomeAsUpIndicator", Array(0))

End Sub

Sub B4XPage_CloseRequest As ResumableSub

	'home button
	If Main.ActionBarHomeClicked Then Return False

	Return True

End Sub

Private Sub ButtonExit_Click

	If notif.IsInitialized Then notif.Cancel(notifId)
	CloseExistingConnection(True, True) ' True: we don't want UpdateState to be called
	ExitApplication ' I know, this is not recommended :) But this is intended to make sure that all network-related objects get completely reset.

End Sub

Sub ShowWmDebugLog_Click

	' This log may contain information after a fatal exception - just in case

	wmUtils1.DebugLogShow(Application.LabelName)

End Sub

Sub ResetWmDebugLog_Click

	wmUtils1.DebugLogReset

End Sub

Sub ResetContacts_Click

	' After doing this, the B4A server app considers the next contacts sync the first one ever

	Dim sqlAndroid As SQL

	Dim sf As Object
	sf = xui.Msgbox2Async("This will reset the TBirdSync contacts information. The next contacts sync will be processed as if it were the first one ever.", "Are you sure?", "OK", "Cancel", "", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result <> DialogResponse.POSITIVE Then Return

	sqlAndroid = InitSQLandroid
	If sqlAndroid.IsInitialized = False Then Return

	sqlAndroid.BeginTransaction

	Try
		sqlAndroid.ExecNonQuery("DELETE FROM [properties]")
		sqlAndroid.ExecNonQuery("UPDATE [settings] SET [lastsynccontacts]=''")
		sqlAndroid.TransactionSuccessful
		xui.MsgboxAsync("The contacts information has been reset.", appName)
	Catch
		xui.MsgboxAsync("An error occurred while resetting the contacts information:" & CRLF & CRLF & LastException, appName)
	End Try

	sqlAndroid.EndTransaction
	sqlAndroid.Close

End Sub

Sub ResetCalendar_Click

	' After doing this, the B4A server app considers the next calendar/tasks sync the first one ever

	Dim sqlAndroid As SQL

	Dim sf As Object
	sf = xui.Msgbox2Async("This will reset the TBirdSync calendar/tasks information. The next calendar/tasks sync will be processed even if there don't seem to be any changes to sync.", "Are you sure?", "OK", "Cancel", "", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result <> DialogResponse.POSITIVE Then Return

	sqlAndroid = InitSQLandroid
	If sqlAndroid.IsInitialized = False Then Return

	sqlAndroid.BeginTransaction

	Try
		sqlAndroid.ExecNonQuery("UPDATE [settings] SET [lastsynccalendar]=''")
		sqlAndroid.TransactionSuccessful
		xui.MsgboxAsync("The calendar/tasks information has been reset.", appName)
	Catch
		xui.MsgboxAsync("An error occurred while resetting the calendar/tasks information:" & CRLF & CRLF & LastException, appName)
	End Try

	sqlAndroid.EndTransaction
	sqlAndroid.Close

End Sub

Sub EnableButtonSaveActivate

	If txtPort.Text <> "" Then
		If IsNumber(txtPort.Text) Then
			Dim i As Int = txtPort.Text
			If i > 0 Then
				If txtPassword.Text.Length > 0 Then
					ButtonSaveActivate.Visible = True
					Return
				End If
			End If
		End If
	End If

	ButtonSaveActivate.Visible = False

End Sub

Private Sub ButtonSaveActivate_Click

	cfgServerPort = txtPort.Text
	DoWriteSettings(False, "", "")
	ListenForConnections

End Sub

Private Sub CheckBoxStartAtBoot_CheckedChange(Checked As Boolean)

	If settingCheckboxes = False Then DoWriteSettings(False, "", "")

End Sub

Private Sub CheckBoxKeepAlive_CheckedChange(Checked As Boolean)

	If settingCheckboxes = False Then
		If Checked = False Then StopService(KeepAlive)
		DoWriteSettings(False, "", "")
	End If

End Sub

Sub txtPassword_LongClick ' Undocumented but works; does suppress select/cut/copy/paste functionality though

	ToastMessageShow(txtPassword.Text, True)

End Sub

Sub InitSQLandroid As SQL

	' Initialises the TBirdSync database on/from the Android server; creates it if it doesn't exist

	Dim sqlAndroid As SQL

	If File.Exists(dirApp, "tbirdsync.db") Then ' Check if the database is functional
		Try
			sqlAndroid.Initialize(dirApp, "tbirdsync.db", True)
			sqlAndroid.ExecNonQuery("CREATE TABLE IF NOT EXISTS [settings] ([dbversion] INTEGER, [lastsynccontacts] TEXT, [lastsynccalendar] TEXT)")
			sqlAndroid.ExecNonQuery("CREATE TABLE IF NOT EXISTS [properties] ([card] TEXT, [name] TEXT, [value] TEXT)")
		Catch
			wmUtils1.DebugLogWrite("Database init failed: " & LastException)
			If sqlAndroid.IsInitialized Then sqlAndroid.Close
			File.Delete(dirApp, "tbirdsync.db") ' There was a problem, we'll re-create the database
		End Try
	End If

	If File.Exists(dirApp, "tbirdsync.db") = False Then ' Create the database
		Try
			sqlAndroid.Initialize(dirApp, "tbirdsync.db", True)
			sqlAndroid.ExecNonQuery("CREATE TABLE IF NOT EXISTS [settings] ([dbversion] INTEGER, [lastsynccontacts] TEXT, [lastsynccalendar] TEXT)")
			sqlAndroid.ExecNonQuery("CREATE TABLE IF NOT EXISTS [properties] ([card] TEXT, [name] TEXT, [value] TEXT)")
		Catch
			wmUtils1.DebugLogWrite("Database init failed: " & LastException)
			If sqlAndroid.IsInitialized Then sqlAndroid.Close
			Return sqlAndroid
		End Try
	End If

	If sqlAndroid.ExecQuerySingleResult("SELECT count(*) FROM [settings]") = 0 Then ' Create the row in table 'settings'
		sqlAndroid.ExecNonQuery2("INSERT INTO [settings] ([dbversion], [lastsynccontacts], [lastsynccalendar]) VALUES (?, ?, ?)", Array As String(1, "", ""))
	End If

	Return sqlAndroid

End Sub

Sub AStream_NewData_Server(Buffer() As Byte)

	Dim sqlAndroid As SQL
	Dim androidContactsList As List
	Dim mapIn As Map = ser.ConvertBytesToObject(Buffer)
	Dim mapOut As Map

	ReportProgress("Incoming action: " & mapIn.Get("action"), True, "Black")

	mapOut.Initialize

	Select mapIn.Get("action")

		Case "connect"
			ReportProgress("Connection request received from IP " & mapIn.GetDefault("clientip", "?"), True, "Black")
			If mapIn.Get("password") <> txtPassword.Text Then
				ReportProgress("Invalid password received from IP " & mapIn.GetDefault("clientip", "?"), True, "Red")
				mapOut.Put("success", False)
				mapOut.Put("error", "Invalid password")
				SendDataMap(mapOut)
				UpdateState(False)
				Return
			End If
			ReportProgressAndInformClient("Connection succeeded, client IP: " & mapIn.GetDefault("clientip", "?"), "Black")
			randomId = server.GetMyIP & DateTime.now & Rnd(-1000000000, 1000000000)
			ICSx5isPresent(True)
			mapOut.Put("success", True)
			mapOut.Put("randomid", randomId)
			mapOut.Put("svraction", "connected")
			lblClientIP.Text = "Client IP: " & mapIn.GetDefault("clientip", "?")
			Sleep(0)
			' Sync contacts? If only Calendar/Tasks are selected, nothing needs to be done
			' here as we'll just feed the exported .ics file to ICSx5, which will process the data.
			' Also, if no contacts were changed since the last sync, there is no need to collect
			' the Android device's contacts (which takes some time).
			Dim mustSyncContacts As Boolean = wmUtils1.GetFromMapAsBoolean(mapIn, "synccontacts", False)
			If mustSyncContacts Then
				Dim sqlAndroidWasInitialized As Boolean = sqlAndroid.IsInitialized
				sqlAndroid = InitSQLandroid
				If sqlAndroid.IsInitialized = False Then
					ReportProgress("Failed to initialise the Android database", True, "Red")
					mapOut.Initialize
					mapOut.Put("success", False)
					mapOut.Put("error", "Failed to initialise the Android database: " & LastException)
					SendDataMap(mapOut)
					Return
				End If
				Dim numberOfTbirdContacts As Int = wmUtils1.GetFromMapAsInt(mapIn, "numberoftbirdcontacts", False)
				If sqlAndroid.ExecQuerySingleResult("SELECT count(DISTINCT [card]) FROM [properties]") = numberOfTbirdContacts Then ' There might still be changes - or not
					If wmUtils1.NullToEmptyString(sqlAndroid.ExecQuerySingleResult("SELECT [lastsynccontacts] FROM [settings] LIMIT 1")) <> "" Then ' Only continue if 'Reset contacts' was not done, and if this is not the first sync
						Dim latestContactsLastModifiedDate As String = mapIn.GetDefault("latestcontactslastmodifieddate", "")
						If (latestContactsLastModifiedDate <> "") And (cfgSavedLatestContactsLastModifiedDate <> "") Then
							If latestContactsLastModifiedDate.CompareTo(cfgSavedLatestContactsLastModifiedDate) <= 0 Then
								mustSyncContacts = False
								ReportProgressAndInformClient("No contacts were changed since the last sync", "Blue")
							End If
						End If
					End If
				End If
				If sqlAndroidWasInitialized = False Then sqlAndroid.Close
			End If
			mapOut.Put("cansynccontacts", mustSyncContacts)
			If mustSyncContacts Then
				ReportProgressAndInformClient("Adding Android database to data to send to client", "Black")
				sqlAndroid = InitSQLandroid
				If sqlAndroid.IsInitialized Then
					sqlAndroid.Close
				Else
					ReportProgress("Failed to initialise the Android database", True, "Red")
					mapOut.Initialize
					mapOut.Put("success", False)
					mapOut.Put("error", "Failed to initialise the Android database: " & LastException)
					SendDataMap(mapOut)
					Return
				End If
				mapOut.Put("sqlandroid", File.ReadBytes(dirApp, "tbirdsync.db")) ' Send the server database to the client; the client will do the heavy lifting
				androidContactsList.Initialize
				mapOut.Put("contactsandroid", ser.ConvertObjectToBytes(androidContactsList)) ' Send an empty list; action 'deleteandroidcontacts' will request the data if required
			End If ' mustSyncContacts = True
			Dim mustSyncCalendar As Boolean = wmUtils1.GetFromMapAsBoolean(mapIn, "synccalendar", False) And ICSx5isPresent(False)
			If mustSyncCalendar Then
				Dim latestCalendarLastModifiedDate As String = mapIn.GetDefault("latestcalendarlastmodifieddate", "")
				If (latestCalendarLastModifiedDate <> "") And (cfgSavedLatestCalendarLastModifiedDate <> "") Then
					If latestCalendarLastModifiedDate.CompareTo(cfgSavedLatestCalendarLastModifiedDate) <= 0 Then
						mustSyncCalendar = False
						ReportProgressAndInformClient("No calendar/task data were changed since the last sync", "Blue")
					End If
				End If
				mapOut.Put("cansynccalendar", mustSyncCalendar)
			End If
			ReportProgressAndInformClient("Sending data to the client", "Black")
			SendDataMap(mapOut)

		Case "deleteandroidcontacts"
			' Make sure we're talking to the correct client
			Dim rId As String = mapIn.GetDefault("randomid", "")
			If rId <> randomId Then
				mapOut.Put("success", False)
				mapOut.Put("error", "Connection was not yet initiated")
				SendDataMap(mapOut)
				Return
			End If
			mapOut.Put("success", True)
			mapOut.Put("randomid", randomId)
			mapOut.Put("svraction", "deleteandroidcontacts")
			lblDeleting.Visible = True
			lblDeleting.BringToFront
			ReportProgressAndInformClient("Deleting Android contacts, please wait...", "Black")
			Sleep(0)
			Dim numDeleted As Int = 0
			For Each oneContact As cuContact In cu.FindAllContacts(False)
				If cu.DeleteContact2(oneContact.Id) < 1 Then numDeleted = numDeleted + 1
			Next
			lblDeleting.Visible = False
			Sleep(0)
			If numDeleted = 0 Then
				ReportProgressAndInformClient("The Android device's contacts have been deleted", "Black")
			Else
				mapOut.Put("success", False)
				ReportProgressAndInformClient(numDeleted & " contact(s) on the Android device could not be deleted, please delete them manually, then restart the sync", "Red")
			End If
			SendDataMap(mapOut)

		Case "dosync"
			' Make sure we're talking to the correct client
			Dim rId As String = mapIn.GetDefault("randomid", "")
			If rId <> randomId Then
				mapOut.Put("success", False)
				mapOut.Put("error", "Connection was not yet initiated")
				SendDataMap(mapOut)
				Return
			End If
			' Contacts to be synced?
			If mapIn.ContainsKey("syncchanges") Then
				ShowNotification("Syncing", notifIconSyncing)
				ReportProgressAndInformClient("Received contacts data to sync", "Black")
				Wait For (ContactsUpdate(mapIn)) Complete (resltContacts As Boolean)
				ShowNotification("Connected", notifIconConnected)
			End If
			' Calendar/tasks to be synced?
			If mapIn.ContainsKey("syncics") Then
				ReportProgressAndInformClient("Received calendar/tasks data to sync", "Black")
				CalendarAndTasksUpdate(mapIn)
			End If
			' Done
			ReportProgressAndInformClient("Sync completed", "Black")
			CloseExistingConnection(False, False)

	End Select ' mapIn.Get("action")

End Sub

Sub ReportProgressAndInformClient(txt As String, txtColour As String)

	ReportProgress(txt, True, txtColour)
	InformClient(txt, txtColour)

End Sub

Sub ReportProgressAndInformClient2(txt As String)

	ReportProgress2(txt, True)
	InformClient2(txt)

End Sub

Sub InformClient(txt As String, txtColour As String)

	Dim m As Map
	m.Initialize
	m.Put("success", True)
	m.Put("randomid", randomId)
	m.Put("svraction", "info")
	m.Put("info", txt)
	m.Put("txtcolour", txtColour)
	SendDataMap(m)

End Sub

Sub InformClient2(txt As String)

	Dim m As Map
	m.Initialize
	m.Put("success", True)
	m.Put("randomid", randomId)
	m.Put("svraction", "info2")
	m.Put("info2", txt)
	SendDataMap(m)

End Sub

Sub ICSx5isPresent(notifyClient As Boolean) As Boolean

	Dim pm As PackageManager
	Dim l As List = pm.GetInstalledPackages

	If l.IndexOf(ICSx5PackageName) < 0 Then
		Dim s As String = "App 'ICSx5' (" & ICSx5PackageName & ") does not seem to be present on the Android device; tasks and calendar cannot be synchronised"
		If notifyClient Then
			ReportProgressAndInformClient(s, "Blue")
		Else
			ReportProgress(s, True, "Red")
		End If
		Return False
	Else
		Return True	
	End If

End Sub

#End If ' B4A

#End Region ' Core B4A

#Region Contacts B4J

#If B4J

Sub PrepareSyncContacts(afterDeletingAndroidContacts As Boolean) As ResumableSub

	' NOTE: synchronisation is done based on the combination of FirstName and LastName;
	' in the comments in this Sub, this combination is referred to as 'name'.

	' Steps in this Sub:
	' 1. Check if there are unexpected field names in the Thunderbird contacts; if they are found, warn the user as the code may need to be updated to handle them
	' 2. Ensure all names in the Thunderbird database are unique, and fill nameMapTBird, which will be used further on
	' 3. Populate map IDmapTBird with all unique 'card' values from the Thunderbird database, and their 'LastModifiedDate'
	' 4. Populate map IDmapAndroid with all unique 'card' values from the Android db, and their 'LastModifiedDate'
	' 5. Compare IDmapTBird -> IDmapAndroid to look for new or updated entries, and add relevant ones to list syncChanges
	' 6. If changes were detected and 'afterDeletingAndroidContacts' is False, delete the Android contacts' data on the B4A server
	' 7. Compare IDmapAndroid -> IDmapTBird to look for deleted entries, and add relevant ones to list syncChanges
	' 8. Look (using name) for Android device contacts that don't exist in Thunderbird (they will be deleted from the Android device's contacts), and add relevant ones to list syncChanges
	' 9. Show the changes that will be applied, and panels containing 'Apply' and 'Cancel' buttons

	Dim rsTBird As ResultSet
	Dim rsAndroid As ResultSet
	Dim i As Int
	Dim m As Map
	Dim duplicates As String
	Dim s As String
	Dim sbChanges As StringBuilder
	Dim unexpectedNames As String
	Dim sf As Object

	' Close open databases
	If sqlAndroid.IsInitialized Then sqlAndroid.Close
	If sqlPC.IsInitialized Then sqlPC.Close

	' Validate the selected Thunderbird profile directory
	If IsinputDirOK(True) = False Then Return False

	' Open the Thunderbird Address Book database
	Try
		sqlPC.InitializeSQLite(inputDir, "abook.sqlite", False)
	Catch
		Wait For(wmUtils1.MsgBoxLongText(B4XPages.GetNativeParent(Me), 500dip, 300dip, "Couldn't open the Thunderbird database" & CRLF & CRLF & File.Combine(inputDir, "abook.sqlite") & CRLF & CRLF & LastException, appName, "OK", "", "", xui.Color_Red)) Complete (result As Int)
		Return False
	End Try

	' Save and open the TBirdSync database that was received from the Android device
	If File.Exists(dirApp, "sqlandroid.sqlite") Then File.Delete(dirApp, "sqlandroid.sqlite")
	File.WriteBytes(dirApp, "sqlandroid.sqlite", serverDataMap.Get("sqlandroid"))
	Try
		sqlAndroid.InitializeSQLite(dirApp, "sqlandroid.sqlite", False)
	Catch
		Wait For(wmUtils1.MsgBoxLongText(B4XPages.GetNativeParent(Me), 500dip, 300dip, "Couldn't open the Android device's TBirdSync database that was received from the device" & CRLF & CRLF & File.Combine(dirApp, "sqlandroid.sqlite") & CRLF & CRLF & LastException, appName, "OK", "", "", xui.Color_Red)) Complete (result As Int)
		sqlPC.Close
		Return False
	End Try

	If afterDeletingAndroidContacts = False Then
		s = wmUtils1.NullToEmptyString(sqlAndroid.ExecQuerySingleResult("SELECT [lastsynccontacts] FROM [settings] LIMIT 1"))
		If s = "" Then
			sf = xui.Msgbox2Async("This is the first time that contacts are being synchronised with TBirdSync. ALL EXISTING CONTACTS WILL NOW BE DELETED ON THE ANDROID DEVICE so that they will be replaced with Thunderbird's contacts' data. Any contacts that were currently 'starred' will have to be 're-starred' after this first sync. Do you want to do this?", appName, "OK", "Cancel", "", Null)
			Wait For (sf) Msgbox_Result (result As Int)
			If result <> xui.DialogResponse_Positive Then
				sqlAndroid.Close
				sqlPC.Close
				Return False
			End If
		End If
	End If

	' Inits
	waitingForAndroidContactsDeletion = False
	sbChanges.Initialize
	syncChanges.Initialize
	photosMap.Initialize
	If afterDeletingAndroidContacts = False Then
		IDmapTBird.Initialize
		IDmapAndroid.Initialize
	End If

	' Check if there are unexpected field names in the Thunderbird contacts;
	' if they are found, warn the user.
	If afterDeletingAndroidContacts = False Then
		ReportProgress("Checking for unexpected fields in the Thunderbird database", False, "Black")
		rsTBird = sqlPC.ExecQuery("SELECT DISTINCT [name] FROM [properties]")
		unexpectedNames = ""
		Do While rsTBird.NextRow
			s = rsTBird.GetString("name").ToLowerCase
			If contactsFieldsMap.ContainsKey(s) = False Then unexpectedNames = unexpectedNames & s & CRLF
		Loop
		rsTBird.Close
		If unexpectedNames <> "" Then
			sf = xui.Msgbox2Async("New field names were found in the Thunderbird database; the B4J program and B4A app may need to be updated to process these fields. They are:" & CRLF & unexpectedNames & CRLF & CRLF & "Continue?", appName, "OK", "Cancel", "", Null)
			Wait For (sf) Msgbox_Result (Result As Int)
			If Result <> xui.DialogResponse_Positive Then
				sqlAndroid.Close
				sqlPC.Close
				Return False
			End If
		End If
	End If

	' Check if there are duplicate names in the Thunderbird contacts;
	' we can't have that, as we'll be matching contacts by name.
	' Also fill nameMapTBird, which will be used further on.
	If afterDeletingAndroidContacts = False Then
		ReportProgress("Verifying that all names in the Thunderbird database are unique", False, "Black")
		rsTBird = sqlPC.ExecQuery("SELECT DISTINCT [card] FROM [properties]")
		duplicates = ""
		m.Initialize
		nameMapTBird.Initialize
		i = 0
		Do While rsTBird.NextRow
			i = i + 1
			If i Mod 10 = 0 Then ReportProgress2("Verifying that all names in the Thunderbird database are unique - " & i, False)
			s = ContactsGetFullNameFromDb(sqlPC, rsTBird.GetString("card"), False)
			nameMapTBird.Put(s.ToLowerCase, "")
			If m.ContainsKey(s.ToLowerCase) Then
				duplicates = duplicates & s & CRLF
			Else
				m.Put(s.ToLowerCase, "")
			End If
		Loop
		rsTBird.Close
		If duplicates <> "" Then
			xui.MsgboxAsync("One or more duplicate names exist in the Thunderbird contacts; please make sure there are no such duplicates. The duplicate names that were found are:" & CRLF & duplicates, appName)
			sqlAndroid.Close
			sqlPC.Close
			Return False
		End If
	End If

	' Populate map IDmapTBird with all unique 'card' values from the Thunderbird database, and their 'LastModifiedDate'
	If afterDeletingAndroidContacts = False Then
		ReportProgress("Fetching unique IDs and their last modification date from the Thunderbird database", False, "Black")
		rsTBird = sqlPC.ExecQuery("SELECT * FROM [properties] WHERE [name]='LastModifiedDate'")
		i = 0
		Do While rsTBird.NextRow
			i = i + 1
			If i Mod 10 = 0 Then ReportProgress2("Fetching unique IDs and their last modification date from the Thunderbird database - " & i, False)
			IDmapTBird.Put(rsTBird.GetString("card"), rsTBird.GetString("value"))
		Loop
		rsTBird.Close
	End If

	' Populate map IDmapAndroid with all unique 'card' values from the Android db, and their 'lastmodifieddate'
	If afterDeletingAndroidContacts = False Then
		ReportProgress("Fetching unique IDs and their last modification date from the TBirdSync database", False, "Black")
		rsAndroid = sqlAndroid.ExecQuery("SELECT * FROM [properties] WHERE [name]='lastmodifieddate'")
		i = 0
		Do While rsAndroid.NextRow
			i = i + 1
			If i Mod 10 = 0 Then ReportProgress2("Fetching unique IDs and their last modification date from the TBirdSync database - " & i, False)
			IDmapAndroid.Put(rsAndroid.GetString("card"), rsAndroid.GetString("value"))
		Loop
		rsAndroid.Close
	End If

	' Compare IDmapTBird -> IDmapAndroid to look for new or updated entries
	ReportProgress("Looking for added and updated entries", False, "Black")
	i = 0
	For Each card As String In IDmapTBird.Keys
		i = i + 1
		If (i Mod 10 = 0) Or (i = IDmapTBird.Size) Then ReportProgress2("Looking for added and updated entries - " & i, False)
		Dim lastModTBird As String = IDmapTBird.GetDefault(card, "")
		Dim lastModAndroid As String = IDmapAndroid.GetDefault(card, "")
		If lastModTBird = lastModAndroid Then Continue ' LastModifiedDate has not changed
		Dim action As Int
		If lastModAndroid = "" Then ' No entry found in the Android database
			action = ACTION_ADD
		Else
			action = ACTION_UPDATE
			' Check if any relevant (i.e. used by the B4A server) fields have been changed;
			' if not, we don't need to process this contact. This is done primarily because
			' when exchanging emails with a contact, Thunderbird internally updates its
			' 'popularity index' field as well as 'lastmodifieddate', which can yield many
			' unnecessary false positives. This in turn causes the B4A server to collect
			' all Android contacts, which takes time.
			Dim relevantChange As Boolean = False
			Dim mapPC As Map = ResultSetToMap(sqlPC.ExecQuery2("SELECT * FROM [properties] WHERE [card]=?", Array As String(card)), "name", "value")
			Dim mapAndroid As Map = ResultSetToMap(sqlAndroid.ExecQuery2("SELECT * FROM [properties] WHERE [card]=?", Array As String(card)), "name", "value")
			For Each key As String In mapPC.Keys
				s = contactsFieldsMap.GetDefault(key.ToLowerCase, "")
				If s.ToLowerCase = "y" Then
					' This field is relevant; check if the values on PC and Android differ;
					' if so, a relevant change is found
					If wmUtils1.GetFromMapAsString(mapPC, key, "") <> wmUtils1.GetFromMapAsString(mapAndroid, key, "") Then
						relevantChange = True
						Exit
					End If
				End If
			Next
			If relevantChange = False Then Continue
		End If
		Dim rsOneContactPC As ResultSet = sqlPC.ExecQuery2("SELECT * FROM [properties] WHERE [card]=?", Array As String(card))
		s = ContactsGetFullNameFromDb(sqlPC, card, False)
		syncChanges.Add(ContactsCreateSyncChange(card, s, action, "lastModTBird/Android=" & lastModTBird & "/" & lastModAndroid, s, ResultSetToMap(rsOneContactPC, "name", "value")))
		rsOneContactPC.Close
	Next

	' If this is the first sync or 'Reset contacts' was done, delete the Android device's contacts
	If afterDeletingAndroidContacts = False Then
		If wmUtils1.NullToEmptyString(sqlAndroid.ExecQuerySingleResult("SELECT [lastsynccontacts] FROM [settings] LIMIT 1")) = "" Then
			waitingForAndroidContactsDeletion = True
			ReportProgress("Requesting the B4A server to delete all Android contacts; this is done the first time contacts are synchronised, or after using menu option 'Reset contacts' in the B4A app", False, "Blue")
			Dim mapOut As Map
			mapOut.Initialize
			mapOut.Put("action", "deleteandroidcontacts")
			SendDataMap(mapOut)
			Return True
		End If
	End If

	' Compare IDmapAndroid -> IDmapTBird to look for entries that were deleted in Thunderbird
	ReportProgress("Looking for deleted entries", False, "Black")
	i = 0
	For Each card As String In IDmapAndroid.Keys
		i = i + 1
		If (i Mod 10 = 0) Or (i = IDmapAndroid.Size) Then ReportProgress2("Looking for deleted entries - " & i, False)
		If IDmapTBird.ContainsKey(card) = False Then
			s = ContactsGetFullNameFromDb(sqlAndroid, card, True)
			syncChanges.Add(ContactsCreateSyncChange(card, s, ACTION_DELETE, "", s, Null))
		End If
	Next

	' No changes?
	If syncChanges.Size < 1 Then
		ReportProgress("There are no changed contacts", False, "Blue")
		sqlAndroid.Close
		sqlPC.Close
		Return True
	End If

	' For debugging with a limited number of contacts
'	Dim keepContactIfNameContains As String = "aaaa"
'	For i = (syncChanges.Size - 1) To 0 Step -1
'		Dim chg As syncChange = syncChanges.Get(i)
'		If chg.name.ToLowerCase.Contains(keepContactIfNameContains) = False Then syncChanges.RemoveAt(i)
'	Next

	ReportProgress("Collecting photos", False, "Black")
	i = 0
	For Each oneChange As syncChange In syncChanges
		i = i + 1
		If (i Mod 10 = 0) Or (i = syncChanges.Size) Then  ReportProgress2("Collecting photos - " & i, False)
		Select Case oneChange.action
			Case ACTION_DELETE, ACTION_DELETE_ANDROID
				' No action
			Case Else ' Add the photo (if there is one) to 'photosMap' with key=card and data=serialized photo file
				s = wmUtils1.NullToEmptyString(sqlPC.ExecQuerySingleResult2("SELECT [value] FROM [properties] WHERE ([card]=? AND [name]=?)", Array As String(oneChange.card, "PhotoName")))
				If s = "" Then Continue ' No photo registered in the Thunderbird db
				If File.Exists(dirPhotos, s) = False Then Continue ' A photo is registered but the file doesn't exist
				photosMap.Put(oneChange.card, File.ReadBytes(dirPhotos, s))
		End Select
	Next

	' Sort list 'syncChanges'
	syncChanges.SortType("sortName", True)

	' Show the changes
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 10dip, 10dip, B4XPages.GetNativeParent(Me).Width - 20dip, B4XPages.GetNativeParent(Me).Height - 190dip)
	p.LoadLayout("CustomListViewDialog")
	CustomListViewDialog.AsView.SetLayoutAnimated(0, 5dip, 5dip, p.Width - 10dip, p.Height - 10dip)

	ReportProgress("Showing changed contacts", False, "Black")
	i = 0
	For Each oneChange As syncChange In syncChanges
		i = i + 1
		If (i Mod 10 = 0) Or (i = syncChanges.Size) Then ReportProgress2("Showing changed contacts - " & i, False)
		Select Case oneChange.action
			Case ACTION_ADD
				CustomListViewDialog.AddTextItem(i & "-" & oneChange.sortName & " (new)", "")
			Case ACTION_DELETE
				CustomListViewDialog.AddTextItem(i & "-" & oneChange.sortName & " (deleted in Thunderbird)", "")
			Case ACTION_UPDATE
				CustomListViewDialog.AddTextItem(i & "-" & oneChange.sortName & " (updated)", "")
			Case ACTION_DELETE_ANDROID
				CustomListViewDialog.AddTextItem(i & "-" & oneChange.sortName & " (delete from device, not present in Thunderbird)", "")
		End Select
	Next

	' Close the databases
	sqlPC.Close
	sqlAndroid.Close

	' Ask user confirmation
	dialog.Initialize(Root)
	dialog.Title = "Contacts that will be updated on the Android device"
	dialog.BackgroundColor = xui.Color_RGB(0, 191, 255) ' DeepSkyBlue
	Dim rs As ResumableSub = dialog.ShowCustom(p, "OK", "", "Cancel")
	Wait For (rs) Complete(Result As Int)
	dialog.PutAtTop = False
	If result <> xui.DialogResponse_Positive Then
		ReportProgress("Synchronisation cancelled, no data will be synchronised", False, "Blue")
		CloseExistingConnection(False, False)
		Return False
	End If

	' Success
	Return True

End Sub

Sub ContactsGetFullNameFromDb(db As SQL, card As String, downShiftColumnNames As Boolean) As String

	Return ContactsComposeFullName(ContactsGetPropertyFromDb(db, card, "FirstName", downShiftColumnNames), ContactsGetPropertyFromDb(db, card, "LastName", downShiftColumnNames))

End Sub

Sub ContactsGetPropertyFromDb(db As SQL, card As String, propertyName As String, downShiftColumnNames As Boolean) As String

	If downShiftColumnNames Then
		Return wmUtils1.NullToEmptyString(db.ExecQuerySingleResult2("SELECT [value] FROM [properties] WHERE ([card]=? AND [name]=?)", Array As String(card, propertyName.ToLowerCase)))
	Else
		Return wmUtils1.NullToEmptyString(db.ExecQuerySingleResult2("SELECT [value] FROM [properties] WHERE ([card]=? AND [name]=?)", Array As String(card, propertyName)))
	End If

End Sub

'Sub ContactsGetFullNameFromCuContact(cc As contactDetailsThunderbird) As String
'
'	Return ContactsComposeFullName(cc.firstName, cc.lastName)
'
'End Sub

Sub ContactsComposeFullName(firstName As String, lastName As String) As String

	If (lastName = Null) Or (lastName = "") Then
		Return firstName
	Else If (firstName = Null) Or (firstName = "") Then
		Return lastName
	Else
		Return lastName & ", " & firstName
	End If

End Sub

Sub ContactsCreateSyncChange(card As String, name As String, action As Int, debugInfo As String, sortName As String, allData As Map) As syncChange

	Dim t1 As syncChange
	t1.Initialize
	t1.card = card
	t1.name = name
	t1.action = action
	t1.debugInfo = debugInfo
	t1.sortName = wmUtils1.ProperCase(sortName)
	If allData.IsInitialized Then
		t1.allData = allData
	Else
		t1.allData.Initialize
	End If
	Return t1

End Sub

Sub ResultSetToMap(rs As ResultSet, keyColumn As String, valueColumn As String) As Map

	Dim m As Map
	m.Initialize
	Do While rs.NextRow
		m.Put(rs.GetString(keyColumn).ToLowerCase, rs.GetString(valueColumn))
	Loop
	Return m

End Sub

#End If ' B4J

#End Region ' Contacts B4J

#Region Contacts B4A

#If B4A

Private Sub ContactsUpdate(mapIn As Map) As ResumableSub

	' NOTE: synchronisation is done based on the combination of FirstName and LastName;
	' in the comments in this Sub, this combination is referred to as 'name'.

	Dim mapOut As Map
	Dim i As Int
	Dim success As Boolean = False
	Dim s As String
	Dim numAdded As Int = 0
	Dim numUpdated As Int = 0
	Dim numDeleted As Int = 0
	Dim numDeletedAndroid As Int = 0
	Dim lstPhotos As List

	syncChanges = mapIn.Get("syncchanges")
	photosMap = mapIn.Get("photos")

	' Close open databases
	If sqlAndroid.IsInitialized Then sqlAndroid.Close

	' Save and open the TBirdSync database that was updated by the B4J client
	ReportProgressAndInformClient("Opening the Android device's TBirdSync database", "Black")
	Try
		sqlAndroid.Initialize(dirApp, "tbirdsync.db", False)
	Catch
		ContactsUpdateError("Couldn't open the Android device's TBirdSync database" & CRLF & CRLF & File.Combine(dirApp, "tbirdsync.db") & CRLF & CRLF & LastException)
		File.Delete(dirApp, "abook.sqlite")
		Return False
	End Try

	mapOut.Initialize

	'Do updates using the info in list 'syncChanges'
	ReportProgressAndInformClient("Updating contacts", "Black")

	sqlAndroid.BeginTransaction

	Try
		i = 0
		For Each oneChange As syncChange In syncChanges
			Sleep(0)
			i = i + 1
			' Metrics
			Select Case oneChange.action
				Case ACTION_ADD
					numAdded = numAdded + 1
					s = "new"
				Case ACTION_DELETE
					numDeleted = numDeleted + 1
					s = "deleted in Thunderbird"
				Case ACTION_DELETE_ANDROID
					numDeletedAndroid = numDeletedAndroid + 1
					s = "delete from device, not present in Thunderbird"
				Case ACTION_UPDATE
					numUpdated = numUpdated + 1
					s = "updated"
				Case Else
					s = "????"
			End Select
			If i = 1 Then
				' Show the first line as a new line
				ReportProgressAndInformClient("Updating contacts - " & i & "/" & syncChanges.Size & " - " & oneChange.name & " (" & s & ")", "Black")
			Else
				' Use subsequent lines to replace the first line, rather than adding new ones all the time
				ReportProgressAndInformClient2("Updating contacts - " & i & "/" & syncChanges.Size & " - " & oneChange.name & " (" & s & ")")
			End If
			' Delete existing data from the Android db
			sqlAndroid.ExecNonQuery2("DELETE FROM [properties] WHERE [card]=?", Array As String(oneChange.card))
			' Copy the data from the Thunderbird database to the Android db?
			Select Case oneChange.action
				Case ACTION_DELETE, ACTION_DELETE_ANDROID
				Case Else
					If oneChange.allData.IsInitialized Then
						' Save all of the Thunderbird contact's data in the TBirdSync database
						For Each propertyName As String In oneChange.allData.Keys
							sqlAndroid.ExecNonQuery2("INSERT INTO [properties] ([card], [name], [value]) VALUES (?, ?, ?)", Array As String(oneChange.card, propertyName, oneChange.allData.GetDefault(propertyName, "")))
						Next
					End If
			End Select
			' Delete the existing Android contact(s)
			Dim saveStarred As Boolean = False
			For Each foundContact As cuContact In cu.FindContactsByName(oneChange.name, True, False)
				If ContactsUpdateDeleteOneContact(foundContact.Id, oneChange.name, oneChange.action) Then saveStarred = True
			Next
			' Add the new or updated contact to the Android contacts?
			Dim mustContinue As Boolean = False
			Select Case oneChange.action
				Case ACTION_ADD, ACTION_UPDATE
					' Go on
				Case Else
					mustContinue = True
					Continue ' No further action needed
			End Select
			If mustContinue Then Continue ' 'Continue' within the above 'Select' did NOT continue !
			' Create the new Android contact
			Dim newContactName As cuContactName
			newContactName.FamilyName = oneChange.allData.GetDefault("lastname", "")
			newContactName.GivenName = oneChange.allData.GetDefault("firstname", "")
			Dim newContact As cuContact = cu.InsertContactWithDetailedName(newContactName, "", oneChange.name)
			cu.SetStarred(newContact.Id, saveStarred)
			If oneChange.allData.GetDefault("_aimscreenname", "") <> "" Then cu.AddIM(newContact.Id, oneChange.allData.Get("_aimscreenname"), "aim")
			If oneChange.allData.GetDefault("_googletalk", "") <> "" Then cu.AddIM(newContact.Id, oneChange.allData.Get("_googletalk"), "hangouts")
			If oneChange.allData.GetDefault("_icq", "") <> "" Then cu.AddIM(newContact.Id, oneChange.allData.Get("_icq"), "icq")
			If oneChange.allData.GetDefault("_jabberid", "") <> "" Then cu.AddIM(newContact.Id, oneChange.allData.Get("_jabberid"), "jabber")
			If oneChange.allData.GetDefault("_msn", "") <> "" Then cu.AddIM(newContact.Id, oneChange.allData.Get("_msn"), "msn")
			If oneChange.allData.GetDefault("_qq", "") <> "" Then cu.AddIM(newContact.Id, oneChange.allData.Get("_qq"), "qq")
			If oneChange.allData.GetDefault("_skype", "") <> "" Then cu.AddIM(newContact.Id, oneChange.allData.Get("_skype"), "skype")
			If oneChange.allData.GetDefault("_yahoo", "") <> "" Then cu.AddIM(newContact.Id, oneChange.allData.Get("_yahoo"), "yahoo")
			If oneChange.allData.GetDefault("cellularnumber", "") <> "" Then cu.AddPhone(newContact.Id, oneChange.allData.Get("cellularnumber"), "mobile")
			If oneChange.allData.GetDefault("faxnumber", "") <> "" Then cu.AddPhone(newContact.Id, oneChange.allData.Get("faxnumber"), "other_fax")
			If oneChange.allData.GetDefault("homephone", "") <> "" Then cu.AddPhone(newContact.Id, oneChange.allData.Get("homephone"), "home")
			If oneChange.allData.GetDefault("nickname", "") <> "" Then cu.AddNickname(newContact.Id, oneChange.allData.Get("nickname"), "default")
			s = oneChange.allData.GetDefault("notes", "")
			If oneChange.allData.GetDefault("custom1", "") <> "" Then
				If s <> "" Then s = s & CRLF
				s = s & "Custom 1: " & oneChange.allData.Get("custom1")
			End If
			If oneChange.allData.GetDefault("custom2", "") <> "" Then
				If s <> "" Then s = s & CRLF
				s = s & "Custom 2: " & oneChange.allData.Get("custom2")
			End If
			If oneChange.allData.GetDefault("custom3", "") <> "" Then
				If s <> "" Then s = s & CRLF
				s = s & "Custom 3: " & oneChange.allData.Get("custom3")
			End If
			If oneChange.allData.GetDefault("custom4", "") <> "" Then
				If s <> "" Then s = s & CRLF
				s = s & "Custom 4: " & oneChange.allData.Get("custom4")
			End If
			If s <> "" Then cu.AddNote(newContact.Id, s)
			If oneChange.allData.GetDefault("pagernumber", "") <> "" Then cu.AddPhone(newContact.Id, oneChange.allData.Get("pagernumber"), "pager")
			If oneChange.allData.GetDefault("primaryemail", "") <> "" Then cu.AddEmail(newContact.Id, oneChange.allData.Get("primaryemail"), "home")
			If oneChange.allData.GetDefault("secondemail", "") <> "" Then cu.AddEmail(newContact.Id, oneChange.allData.Get("secondemail"), "work")
			If oneChange.allData.GetDefault("webpage1", "") <> "" Then cu.AddWebsite(newContact.Id, oneChange.allData.Get("webpage1"), "work")
			If oneChange.allData.GetDefault("webpage2", "") <> "" Then cu.AddWebsite(newContact.Id, oneChange.allData.Get("webpage2"), "home")
			If oneChange.allData.GetDefault("workphone", "") <> "" Then cu.AddPhone(newContact.Id, oneChange.allData.Get("workphone"), "work")
			cu.AddPostalAddress2(newContact.Id, "home", oneChange.allData.GetDefault("homeaddress", ""), oneChange.allData.GetDefault("homeaddress2", ""), oneChange.allData.GetDefault("homecity", ""), oneChange.allData.GetDefault("homecountry", ""), oneChange.allData.GetDefault("homestate", ""), oneChange.allData.GetDefault("homezipcode", ""))
			cu.AddPostalAddress2(newContact.Id, "work", oneChange.allData.GetDefault("workaddress", ""), oneChange.allData.GetDefault("workaddress2", ""), oneChange.allData.GetDefault("workcity", ""), oneChange.allData.GetDefault("workcountry", ""), oneChange.allData.GetDefault("workstate", ""), oneChange.allData.GetDefault("workzipcode", ""))
			If (oneChange.allData.GetDefault("birthday", "") <> "") And (oneChange.allData.GetDefault("birthmonth", "") <> "") And (oneChange.allData.GetDefault("birthyear", "") <> "") Then
				cu.AddEvent(newContact.Id, oneChange.allData.Get("birthyear") & "-" & oneChange.allData.Get("birthmonth") & "-" & oneChange.allData.Get("birthday"), "birthday")
			End If
			If (oneChange.allData.GetDefault("company", "") <> "") Or (oneChange.allData.GetDefault("department", "") <> "") Or (oneChange.allData.GetDefault("jobtitle", "") <> "") Then
				Dim ncorg As cuOrganization
				ncorg.Title = oneChange.allData.GetDefault("jobtitle", "")
				If oneChange.allData.GetDefault("company", "") = "" Then
					ncorg.Company = oneChange.allData.GetDefault("department", "")
				Else If oneChange.allData.GetDefault("department", "") = "" Then
					ncorg.Company = oneChange.allData.GetDefault("company", "")
				Else
					ncorg.Company = oneChange.allData.GetDefault("company", "") & CRLF & oneChange.allData.GetDefault("department", "")
				End If
				cu.AddOrganization(newContact.Id, ncorg)
			End If
			If oneChange.allData.GetDefault("phototype", "") = "file" Then
				If photosMap.ContainsKey(oneChange.card) Then
					s = oneChange.card & ".png"
					If File.Exists(dirPhotos, s) Then File.Delete(dirPhotos, s)
					File.WriteBytes(dirPhotos, s, photosMap.Get(oneChange.card))
					cu.SetPhotoFromFile(newContact.Id, dirPhotos, s)
				End If
			End If
		Next
		sqlAndroid.TransactionSuccessful
		success = True
	Catch
		ContactsUpdateError("An error occurred while synchronising the contacts information; the Android device's contacts data may have been changed (use option 'Reset contacts' to start afresh):" & CRLF & CRLF & LastException)
	End Try
	sqlAndroid.EndTransaction

	If success Then
		sqlAndroid.ExecNonQuery2("UPDATE [settings] SET [lastsynccontacts]=?", Array As String(wmUtils1.DateToTimeStampForFilename(DateTime.Now)))
	End If

	syncChanges.Clear

	ReportProgressAndInformClient("Removing photo files of contacts that no longer exist", "Black")
	lstPhotos = File.ListFiles(dirPhotos)
	If lstPhotos.IsInitialized Then
		For Each onePhoto As String In lstPhotos
			i = onePhoto.IndexOf(".")
			If i < 1 Then Continue
			s = onePhoto.SubString2(0, i)
			If sqlAndroid.ExecQuerySingleResult2("SELECT count(*) FROM [properties] WHERE [card]=?", Array As String(s)) = 0 Then ' Card not found in the database, delete the photo file
				File.Delete(dirPhotos, onePhoto)
			End If
		Next
	End If

	If success Then
		cfgSavedLatestContactsLastModifiedDate = mapIn.GetDefault("latestcontactslastmodifieddate", "")
		DoWriteSettings(True, "savedlatestcontactslastmodifieddate", cfgSavedLatestContactsLastModifiedDate)
		If syncChanges.Size > 0 Then
			ReportProgress("Contacts have been updated:" & CRLF & "- Added: " & numAdded & CRLF & "- Deleted: " & numDeleted & CRLF & "- Deleted from device: " & numDeletedAndroid & CRLF & "- Updated: " & numUpdated, True, "Black")
			mapOut.Put("success", True)
			mapOut.Put("svraction", "syncd")
			mapOut.put("metrics", "Contacts have been updated:" & CRLF & "- Added: " & numAdded & CRLF & "- Deleted: " & numDeleted & CRLF & "- Deleted from device: " & numDeletedAndroid & CRLF & "- Updated: " & numUpdated)
			SendDataMap(mapOut)
		End If
	End If

	Return success

End Sub

Sub ContactsUpdateDeleteOneContact(id As Long, name As String, action As Int) As Boolean

	If id < 0 Then Return False

	Try
		Dim wasStarred As Boolean = cu.GetStarred(id)
		' NOTE: when testing on Android 5.1.1 on an Amazon Fire tablet,
		' the DeleteContact methods appeared to have worked, but the contacts
		' were still present in the Contacts app. On a Moto X Style phone
		' with Android 7, it worked well.
		If cu.DeleteContact(id) < 1 Then Log("Contactsupdate - it seems delete contact didn't happen: " & name.ToLowerCase & "; id=" & id & "; name from id=" & cu.GetNameFromId(id) & ";action=" & action)
		Return wasStarred
	Catch
		Log("Contactsupdate - delete contact error: " & name.ToLowerCase & "; id=" & id & ";action=" & action &  "; " & LastException)
		Return False
	End Try

End Sub

Sub ContactsUpdateError(txt As String)

	Dim mapOut As Map
	mapOut.Initialize
	mapOut.Put("success", False)
	mapOut.put("error", txt)
	SendDataMap(mapOut)

	ReportProgress(txt, True, "Red")

End Sub

#End If ' B4A

#End Region ' Contacts B4A

#Region Calendar and Contacts B4J

#If B4J

Sub PrepareSyncCalendarAndTasks

	' Prepare the calendar/tasks data for sync

	Dim wmICSvtodoToVevent1 As wmICSvtodoToVevent
	Dim zip As Zips
	Dim icsFile As String = File.Combine(dirApp, "todo2event.ics")
	Dim zipFile As String = File.Combine(dirApp, "todo2event.zip")

	syncReadyCalendarAndTasks = False

	ReportProgress("Preparing file " & icsFile, False, "Black")

	wmICSvtodoToVevent1.Initialize(cfgIcsFile, "")
	If wmICSvtodoToVevent1.InitializedOK <> "" Then
		ReportProgress("Could not sync calendar/tasks: " & wmICSvtodoToVevent1.InitializedOK, False, "Red")
		Return
	End If

	If File.Exists(icsFile, "") Then File.Delete(icsFile, "")

	' Convert the VTODO (task) entries in the .ics file to VEVENT (calendar) entries - see module wmICSvtodoToVevent
	latestLastModifiedICSentry = wmICSvtodoToVevent1.VTODOtoVEVENT(icsFile, "", False, False, "(T)", "", 0)
	If latestLastModifiedICSentry = "" Then
		ReportProgress("Calendar/tasks sync preparation failed", False, "Red")
		Return
	End If

	ReportProgress("File " & icsFile & " was prepared (" & File.Size(icsFile, "") & " bytes); creating the zipped version", False, "Black")

	If File.Exists(zipFile, "") Then
		Try
			File.Delete(zipFile, "")
		Catch
			ReportProgress("Could not delete file " & zipFile & ": " & LastException, False, "Red")
			Return
		End Try
	End If

	Try
		Dim zip As Zips = ZT_New.NewZips ' Create an empty zip file
		zip.Destination(zipFile,"") ' Set the target zip file
		zip.AddFile(icsFile, "")
		zip.SetPreserveTimestamps(True)
		zip.Process
		ReportProgress("File " & zipFile & " was created", False, "Black")
	Catch
		ReportProgress("File " & zipFile & " could not be created: " & LastException, False, "Red")
		Return
	End Try

	syncReadyCalendarAndTasks = True

End Sub

#End If ' B4J

#End Region ' Calendar and Contacts B4J

#Region Calendar and Contacts B4A

#If B4A

Sub CalendarAndTasksUpdate(mapIn As Map)

	' Start app ICSx5; the user will have to pull to refresh (unless scheduled sync is setup there).
	' Possibly in a later version, the sync will be triggered automatically. I have asked (April 2021)
	' the ICSx5 devs if they would be willing to provide an Intent to do this; it's on their todo list.

	Dim Intent1 As Intent
	Dim pm As PackageManager
	Dim dbTimeStamp As String = wmUtils1.DateToTimeStampForFilename(DateTime.Now)

	If ICSx5isPresent(True) = False Then Return

	If File.Exists(dirApp, "todo2event.ics") Then File.Delete(dirApp, "todo2event.ics")
	' Old method, without zipped file
	'Dim l As List = mapIn.Get("syncics")
	'File.WriteList(dirApp, "todo2event.ics", l)
	If File.Exists(dirApp, "todo2event.zip") Then File.Delete(dirApp, "todo2event.zip")
	File.WriteBytes(dirApp, "todo2event.zip", mapIn.Get("syncics"))
	Try
		ReportProgressAndInformClient("Unzipping 'todo2event.zip' (" & 	File.Size(dirApp, "todo2event.zip") & " bytes) starts", "Black")
		Dim unzip As Zips = ZT_New.NewZipsExisting(dirApp, "todo2event.zip")
		unzip.Destination(dirApp, "")
		unzip.Unpack
		unzip.Process
		ReportProgressAndInformClient("Unzipping 'todo2event.zip' completed; unzipped file size=" & File.Size(dirApp, "todo2event.ics") & " bytes", "Black")
	Catch
		ReportProgressAndInformClient("Unzipping 'todo2event.zip' failed: " & LastException, "Red")
		Return
	End Try

	If File.Exists(dirApp, "todo2event.ics") = False Then
		ReportProgressAndInformClient("Unzipping 'todo2event.zip' seems to have failed", "Red")
		Return
	End If

	Try
		Intent1 = pm.GetApplicationIntent(ICSx5PackageName)
	Catch
		ReportProgressAndInformClient("App 'ICSx5' (" & ICSx5PackageName & ") doesn't seem to exist on the Android device; tasks and calendar were not synchronised", "Red")
		Return
	End Try

	Try
		ReportProgressAndInformClient("Starting app 'ICSx5' on the Android device; pull to sync tasks and calendar; the URI to use for the ics file is (use menu option 'Copy .ics URI to Clipboard' on the device to copy it to the Clipboard): file://" & File.Combine(dirApp, "todo2event.ics"), "Black")
		StartActivity (Intent1)
	Catch
		ReportProgressAndInformClient("App 'ICSx5' (" & ICSx5PackageName & ") could not be started on the Android device; tasks and calendar were not synchronised: " & LastException, "Red")
		Return
	End Try

	' Now we're assuming that the sync was successfully done with ICSx5;
	' we're counting on the user to have done a 'pull to refresh' and not
	' just backed out of ICSx5
	cfgSavedLatestCalendarLastModifiedDate = mapIn.GetDefault("latestcalendarlastmodifieddate", "")
	DoWriteSettings(True, "savedlatestcalendarlastmodifieddate", cfgSavedLatestCalendarLastModifiedDate)

	Try
		Dim sqlAndroid As SQL = InitSQLandroid
		If sqlAndroid.IsInitialized = False Then Return
		sqlAndroid.ExecNonQuery2("UPDATE [settings] SET [lastsynccalendar]=?", Array As String(dbTimeStamp))
	Catch
		ReportProgressAndInformClient("A database error occurred:" & CRLF & CRLF & LastException, "Red")
	End Try

	If sqlAndroid.IsInitialized Then sqlAndroid.Close

End Sub

#End If

#End Region ' Calendar and Contacts B4A