﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.85
@EndOfDesignText@
#Region Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	' Debugging
	Public appDebugLogs As StringBuilder
	Public appDebugLogcat As LogCat

	' Screen orientations
	Public ORIENTATION_LANDSCAPE As Int = 0
	Public ORIENTATION_PORTRAIT As Int = 1

End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

	appDebugLogs.Initialize
#If RELEASE
	appDebugLogcat.LogCatStart(Array As String("-v","raw","*:F","B4A:v"), "logcat")
#End If

End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean

	' Based on https://www.b4x.com/android/forum/threads/uncaught-exceptions.59805

	'wait for 500ms to allow the logs to be updated.
	Dim jo As JavaObject
	Dim l As Long = 500
	jo.InitializeStatic("java.lang.Thread").RunMethod("sleep", Array(l))

	appDebugLogcat.LogCatStop
	appDebugLogs.Append(StackTrace)

	Try
		Dim logfile As TextWriter
		Dim logfileName As String = File.Combine(File.DirInternal, Application.LabelName & ".debuglog.txt")
		logfile.Initialize(File.OpenOutput(logfileName, "", True))
		logfile.WriteLine(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " : " & appDebugLogs)
		logfile.Close
	Catch
		Log("===========================")
		Log("Failed to write to logfile: " & LastException)
		Log("Logfile is: " & logfileName)
		Log("Was attempting to write: " & appDebugLogs)
		Log("===========================")
	End Try

	Return True

End Sub

Sub Service_Destroy

End Sub